Bug 1304325 - Dead lock between Topology updates and connection creation
Dead lock between Topology updates and connection creation
Status: NEW
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: HornetQ (Show other bugs)
6.4.0
Unspecified Unspecified
unspecified Severity high
: ---
: ---
Assigned To: jboss-set
Miroslav Novak
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-03 05:21 EST by mstyk
Modified: 2016-06-14 07:37 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
log produced by org.hornetq.tests.integration.jms.cluster.MultipleThreadsOpeningTest.testMultipleOpen (2.59 MB, text/plain)
2016-02-03 05:21 EST, mstyk
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker JBEAP-1713 Critical Closed [Artemis Testsuite] MultipleThreadsOpeningTest#testMultipleOpen fails 2017-03-03 06:33 EST
Apache JIRA ARTEMIS-217 None None None 2016-02-03 05:21 EST

  None (edit)
Description mstyk 2016-02-03 05:21:54 EST
Created attachment 1120714 [details]
log produced by org.hornetq.tests.integration.jms.cluster.MultipleThreadsOpeningTest.testMultipleOpen

Description of problem:

In a rare case deadlock between topology updates and connection creation may occur. This issue was fixed for ActiveMQ Artemis, but not for HornetQ. Complete information and description of this issue can be found here https://issues.apache.org/jira/browse/ARTEMIS-217
Attaching log of test org.hornetq.tests.integration.jms.cluster.MultipleThreadsOpeningTest.testMultipleOpen where this issue can be hit.
Comment 1 Miroslav Novak 2016-02-03 05:28:34 EST
Fix in ARTEMIS-217 caused another issue described in: https://issues.jboss.org/browse/JBEAP-1713

Fix from ARTEMIS-217 should be adjusted not to block update of "receivedTopology" attribute.
Comment 2 Clebert Suconic 2016-02-03 09:55:01 EST
not really, (unless there's another lock in place, causing a deadlock)... which I don't see indications here.


this is using wait/notify pattern, which means the lock will be released while the wait is in place.
Comment 3 Clebert Suconic 2016-02-03 11:24:05 EST
I meant to say.. I don't think the issue is caused by the change on ARTEMIS-217. If there's an issue it's something else.

I can't replicate it BTW?
Comment 4 Clebert Suconic 2016-02-03 21:02:27 EST
I got confused, thought this was a new request.. fixing it as part of JBEAP-1713
Comment 5 Clebert Suconic 2016-02-03 21:25:21 EST
I fixed JBEAP-1713 but I don't see any relation to this previously fixed issue on ARTEMIS-217. 

I've sent a fix as part of JBEAP-1713: https://github.com/apache/activemq-artemis/pull/369 which will be back ported into the JBoss EAP 7 branch
Comment 6 Miroslav Novak 2016-02-04 02:40:24 EST
ARTEMIS-217 added a synchronized block which delayed/blocked update of receivedTopology attribute in createSessionFactory() method and throw exception. I did not have time to study it deeply so it could be something else as well.
Comment 7 Miroslav Novak 2016-02-04 02:43:54 EST
MultipleThreadsOpeningTest.testMultipleOpen was failing on Artemis bacause of JBEAP-1713. 
As we did not see fix ARTEMIS-217 to be backported to HornetQ and saw that MultipleThreadsOpeningTest.testMultipleOpen test fails sometimes due to client not finished. It indicated that dead lock might be there similar to ARTEMIS-217 could be still in HornetQ.
Comment 8 JBoss JIRA Server 2016-02-08 04:13:36 EST
Erich Duda <eduda@redhat.com> updated the status of jira JBEAP-1713 to Resolved
Comment 9 JBoss JIRA Server 2016-06-14 07:37:48 EDT
Jiri Pallich <jpallich@redhat.com> updated the status of jira JBEAP-1713 to Closed

Note You need to log in before you can comment on or make changes to this bug.